Attribute VB_Name = "modGlobal"
Option Explicit
Option Compare Text

' This program automates different actions within Outwar, an RPG-game.
'Copyright (C) 2004  Kristian S.Stangeland
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hwndOwner As Long, ByVal nFolder As Long, pidl As ITEMIDLIST) As Long
Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Declare Function GetUserName Lib "advapi32.dll" Alias "GetUserNameA" (ByVal lpBuffer As String, nSize As Long) As Long
Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Declare Function GetWindowsVersion Lib "kernel32" Alias "GetVersion" () As Long

Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Declare Sub ZeroMemory Lib "kernel32.dll" Alias "RtlZeroMemory" (Destination As Any, ByVal Length As Long)

' Gdi32 api-cals (Graphics)
Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Declare Function Rectangle Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal H As Long, ByVal W As Long, ByVal E As Long, ByVal O As Long, ByVal W As Long, ByVal i As Long, ByVal U As Long, ByVal S As Long, ByVal C As Long, ByVal OP As Long, ByVal CP As Long, ByVal Q As Long, ByVal PAF As Long, ByVal F As String) As Long
Declare Function DrawTextA Lib "user32" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As Rect, ByVal wFormat As Long) As Long
Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Declare Function SetPixelV Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long

Declare Function SetRect Lib "user32.dll" (lpRect As Rect, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long

' To get the command line (don't know why this was necessary, the COMMAND function didn't work)
Declare Function GetCommandLine Lib "kernel32" Alias "GetCommandLineA" () As Long
Declare Function lstrlen Lib "kernel32" Alias "lstrlenA" (ByVal lpString As Long) As Long

' For the possibility to move the forms Name and Login
Declare Function ReleaseCapture Lib "user32" () As Long
Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

' To get info from the system-register
Declare Function RegOpenKeyEx Lib "advapi32" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, ByRef phkResult As Long) As Long
Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long
Declare Function RegQueryValueEx Lib "advapi32" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, ByRef lpType As Long, ByVal lpData As String, ByRef lpcbData As Long) As Long
Declare Function RegCloseKey Lib "advapi32" (ByVal hKey As Long) As Long
Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long

' For deleting the exit-button in form about
Declare Function GetSystemMenu Lib "user32" (ByVal hwnd As Long, ByVal bRevert As Long) As Long
Declare Function GetMenuItemCount Lib "user32" (ByVal hMenu As Long) As Long
Declare Function DrawMenuBar Lib "user32" (ByVal hwnd As Long) As Long
Declare Function RemoveMenu Lib "user32" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long) As Long

' Se if internet is available
Declare Function InternetAttemptConnect Lib "wininet" (ByVal dwReserved As Long) As Long

' For the XP-style
Declare Sub InitCommonControls Lib "comctl32" ()

' To hide the form from the taskbar
Public Declare Function ShowWindow Lib "user32" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long

' Topmost window
Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

' For hotkey
Declare Function RegisterHotKey Lib "user32" (ByVal hwnd As Long, ByVal id As Long, ByVal fsModifiers As Long, ByVal vk As Long) As Long
Declare Function UnregisterHotKey Lib "user32" (ByVal hwnd As Long, ByVal id As Long) As Long
Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

' To download the PNG image
Declare Function URLDownloadToFile Lib "urlmon" Alias "URLDownloadToFileA" (ByVal pCaller As Long, ByVal szURL As String, ByVal szFileName As String, ByVal dwReserved As Long, ByVal lpfnCB As Long) As Long

' For hotkey
Public Const MOD_ALT = &H1
Public Const MOD_CONTROL = &H2
Public Const MOD_SHIFT = &H4
Public Const PM_REMOVE = &H1
Public Const WM_HOTKEY = &H312
Public Const WM_DESTROY As Long = &H2

Public Const SW_HIDE = 0
Public Const SW_SHOW = 5
Public Const GWL_EXSTYLE = (-20)
Public Const WS_EX_TOOLWINDOW = &H80&

' Topmost window
Public Const HWND_TOPMOST = -1
Public Const HWND_NOTOPMOST = -2
Public Const SWP_NOSIZE = &H1
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOACTIVATE = &H10
Public Const SWP_SHOWWINDOW = &H40

Type HotKey
    ret As Long
    Mod As Long
    Register As Boolean
    Email As String * 30
    Password As String * 30
End Type
 
Type Rect
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Type Buffer
    hdc As Long
    Picture As Long
    Brush As Long
    Font As Long
    Pen As Long
    Rect As Rect
    ScaleWidth As Integer
    ScaleHeight As Integer
End Type

Type AttackItems
    Selected As Boolean
    Text As String
    SubItems() As String
    Tag As String
End Type

Type POINTAPI
    x As Long
    y As Long
End Type

Type Member
    Name As String
    Hits As Long
End Type

Type AttackData
    Ranking As Long
    PlayerName As String
    PowerRating As String
    Money As String
    Bank As String
    Reson As String
    CrewHits As Long
    PostedBy As String
    Tag As String
    SmallIcon As Long
End Type

Type SHITEMID
    cb As Long
    abID As Byte
End Type

Type ITEMIDLIST
    mkid As SHITEMID
End Type

Type FILTERINFO
    Extension As String
    Name As String
    Path As String
    RegPath As String
End Type

Public Enum MS_FILTERTYPES
    eImport
    eExport
End Enum

Const NOERROR As Long = 0
Const MAX_PATH = 260
Const CSIDL_COOKIES As Long = &H21

' For the possibility to move the form Name and Login
Global Const HTCAPTION = 2
Global Const WM_NCLBUTTONDOWN = &HA1
Global Const WM_LBUTTONDBLCLK As Long = &H203
Global Const WM_RBUTTONUP As Long = &H205

' For the createfont
Global Const FW_NORMAL = 400
Global Const FW_BOLD = 700
Global Const OEM_CHARSET = 255
Global Const OEM_FIXED_FONT = 10
Global Const OUT_DEFAULT_PRECIS = 0
Global Const CLIP_DEFAULT_PRECIS = 0
Global Const CLIP_MASK = &HF
Global Const TRANSPARENT = 1
Global Const DEFAULT_QUALITY = 0
Global Const DRAFT_QUALITY = 1
Global Const PROOF_QUALITY = 2

' For the DrawTextA api
Global Const DT_BOTTOM = &H8
Global Const DT_CALCRECT = &H400
Global Const DT_CENTER = &H1
Global Const DT_CHARSTREAM = 4
Global Const DT_DISPFILE = 6
Global Const DT_EXPANDTABS = &H40
Global Const DT_EXTERNALLEADING = &H200
Global Const DT_INTERNAL = &H1000
Global Const DT_LEFT = &H0
Global Const DT_METAFILE = 5
Global Const DT_NOPREFIX = &H800
Global Const DT_NOCLIP = &H100
Global Const DT_PLOTTER = 0
Global Const DT_RASCAMERA = 3
Global Const DT_RASDISPLAY = 1
Global Const DT_RASPRINTER = 2
Global Const DT_RIGHT = &H2
Global Const DT_SINGLELINE = &H20
Global Const DT_TABSTOP = &H80
Global Const DT_TOP = &H0
Global Const DT_VCENTER = &H4
Global Const DT_WORDBREAK = &H10

' Getting information from the system registry
Global Const READ_CONTROL = &H20000
Global Const KEY_QUERY_VALUE = &H1
Global Const KEY_SET_VALUE = &H2
Global Const KEY_CREATE_SUB_KEY = &H4
Global Const KEY_ENUMERATE_SUB_KEYS = &H8
Global Const KEY_NOTIFY = &H10
Global Const KEY_CREATE_LINK = &H20
Global Const StrRun = "SOFTWARE\Microsoft\Windows\CurrentVersion\Run"
Global Const KEY_ALL_ACCESS = KEY_QUERY_VALUE + KEY_SET_VALUE + KEY_CREATE_SUB_KEY + KEY_ENUMERATE_SUB_KEYS + KEY_NOTIFY + KEY_CREATE_LINK + READ_CONTROL
Global Const HKEY_CURRENT_USER = &H80000001
Global Const HKEY_LOCAL_MACHINE = &H80000002
Global Const ERROR_SUCCESS = 0
Global Const REG_SZ = 1
Global Const REG_DWORD = 4
Global Const gREGKEYSYSINFOLOC = "SOFTWARE\Microsoft\Shared Tools Location"
Global Const gREGVALSYSINFOLOC = "MSINFO"
Global Const gREGKEYSYSINFO = "SOFTWARE\Microsoft\Shared Tools\MSINFO"
Global Const gREGVALSYSINFO = "PATH"

' For deleting the exit-button in form about
Global Const MF_BYPOSITION = &H400&
Global Const MF_REMOVE = &H1000&

Global Const WM_USER = &H400
Global Const WM_OUTWAR = WM_USER + &H100

Public CancelIt As Boolean
Public hQueue As Long, y%, HaveSearched As Boolean
Public hTimer As Long
Public Current As POINTAPI
Public LoggedIn As Boolean

Public Msg_End As Boolean
Public Msg_Result As Integer
Public Msg_Subject As String
Public Msg_Text As String

Public pCode As String
Public randNum As Long

Public FightList() As String

Public SkillID As Long
Public Hitreason As String
Public HotKey(8) As HotKey
Public DontCheck As Boolean
Public InvitePlayers As Integer
Public Finish As Boolean
Public MainBuff As String

Global Crypt As New clsCrypting
Global Cookie As String
Global Tray As New Tray
Global ScriptMe As Object

Global CodeGot As Boolean
Global strSecCode As String
Global strCode As String
Global strPage$, strProfile$, strOutwar$, OutwarServer$

Public Const SW_SHOWNORMAL = 1
Public Const GWL_STYLE = (-16)
Public Const ES_NUMBER = &H2000&
Public Const WS_EX_APPWINDOW As Long = &H40000

Public Function GetWinVersion() As String

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "GetWinVersion()", Array(), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***

Dim Ver As Long, WinVer As Long

Ver = GetWindowsVersion()
WinVer = Ver And &HFFFF&

GetWinVersion = Format((WinVer Mod 256) + ((WinVer \ 256) / 100), "Fixed")

End Function

Public Function DownloadFile(URL As String, LocalFilename As String) As Boolean

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "DownloadFile(URL, LocalFilename)", Array(URL, LocalFilename), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***

Dim lngRetVal As Long

lngRetVal = URLDownloadToFile(0, URL, LocalFilename, 0, 0)
If lngRetVal = 0 Then DownloadFile = True

End Function

Public Sub SaveList(List As ListView, File As String, Optional AttackList As Boolean)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "SaveList(List, File, AttackList)", Array(List, File, AttackList), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Dim Free&, Item As ListItem, Tmp As AttackData

Free = FreeFile

Open File For Binary As Free

    Put Free, , AttackList
    Put Free, , CLng(List.ListItems.count)
    
    For Each Item In List.ListItems
        
        With Tmp
        
        Select Case AttackList
        Case True
            .Ranking = Item.Text
            .PlayerName = Item.SubItems(1)
            .PowerRating = Item.SubItems(2)
            .Money = Item.SubItems(3)
            .Bank = Item.SubItems(4)
            .Tag = Item.Tag
        Case False
            .PlayerName = Item.Text
            .PowerRating = Item.SubItems(1)
            .Reson = Item.SubItems(2)
            .CrewHits = Val(Item.SubItems(3))
            .PostedBy = Item.SubItems(4)
            .SmallIcon = Item.SmallIcon
            .Tag = Item.Tag
        End Select
        
        End With
        
        Put Free, , Tmp
    Next
    
Close Free

End Sub

Public Sub OpenList(AttackList As ListView, HitList As ListView, File As String)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "OpenList(AttackList, HitList, File)", Array(AttackList, HitList, File), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Dim Free&, bAttackList As Boolean, Tmp() As AttackData, Cnt&, Tell&

If Dir(File) = "" Then
    MsgBox "The file dosen't exist", vbCritical, "Error"
    Exit Sub
End If

Free = FreeFile

Open File For Binary As Free

    Get Free, , bAttackList
    Get Free, , Cnt
        
    ReDim Tmp(1 To Cnt)
    
    Get Free, , Tmp
    
Close Free

If bAttackList Then
    AttackList.ListItems.Clear
    AttackList.Visible = True
    HitList.Visible = False
Else
    HitList.ListItems.Clear
    HitList.Visible = True
    AttackList.Visible = False
End If

For Tell = 1 To Cnt

    Select Case bAttackList
    Case True
    
        AttackList.ListItems.Add
    
        With AttackList
        .ListItems.Item(Tell).Text = Tmp(Tell).Ranking
        .ListItems.Item(Tell).SubItems(1) = Tmp(Tell).PlayerName
        .ListItems.Item(Tell).SubItems(2) = Tmp(Tell).PowerRating
        .ListItems.Item(Tell).SubItems(3) = Tmp(Tell).Money
        .ListItems.Item(Tell).SubItems(4) = Tmp(Tell).Bank
        .ListItems.Item(Tell).Tag = Tmp(Tell).Tag
        End With
            
    Case False
        
        With HitList
        .ListItems.Item(Tell).Text = Tmp(Tell).PlayerName
        .ListItems.Item(Tell).SubItems(1) = Tmp(Tell).PowerRating
        .ListItems.Item(Tell).SubItems(2) = Tmp(Tell).Reson
        .ListItems.Item(Tell).SubItems(3) = Tmp(Tell).CrewHits
        .ListItems.Item(Tell).SubItems(4) = Tmp(Tell).PostedBy
        .ListItems.Item(Tell).SmallIcon = Tmp(Tell).SmallIcon
        .ListItems.Item(Tell).Tag = Tmp(Tell).Tag
        End With
            
    End Select

Next

End Sub

Public Function GetCode() As Boolean

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "GetCode()", Array(), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***

CodeGot = False

frmCode.wsGetSec.Close
frmCode.wsGetSec.Connect OutwarServer, 80
frmCode.cmdOk.Enabled = False
frmCode.txtSecCode.Text = ""
frmCode.Show

Do Until CodeGot
    DoEvents
    Sleep 10
Loop

strSecCode = frmCode.txtSecCode.Text
GetCode = True

End Function

Public Sub SetShowInTaskbar(Visible As Boolean, hwnd As Long)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "SetShowInTaskbar(Visible, hwnd)", Array(Visible, hwnd), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Dim L As Long

L = ShowWindow(hwnd, SW_HIDE): DoEvents
L = SetWindowLong(hwnd, GWL_EXSTYLE, IIf(Visible, WS_EX_APPWINDOW, WS_EX_TOOLWINDOW)): DoEvents
L = ShowWindow(hwnd, SW_SHOW)

End Sub

Public Function ClassToNumber(Text As String) As Long

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "ClassToNumber(Text)", Array(Text), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***

Select Case LCase(Text)
Case "monster": ClassToNumber = 1
Case "gangster": ClassToNumber = 2
Case "pop star": ClassToNumber = 3
End Select

End Function

Public Sub SaveHotKeys()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "SaveHotKeys()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Dim lCrypt As Boolean, Buff$, Free&

lCrypt = CBool(GetSetting("Outwar", "Advance", "CryptData", 0) = 1)

Free = FreeFile

Open App.Path & "\Hotkey.dat" For Binary As Free
    If lCrypt = False Then Put #Free, , lCrypt
    Put #Free, , HotKey
Close Free

If lCrypt Then
    Free = FreeFile

    Open App.Path & "\Hotkey.dat" For Binary As Free
        Buff = Space(LOF(Free))
        Get #Free, , Buff
    Close Free
    
    Crypt.InBuffer = Buff
    Crypt.Encrypt
    Buff = Crypt.OutBuffer
    
    Free = FreeFile

    Open App.Path & "\Hotkey.dat" For Binary As Free
        Put #Free, , lCrypt
        Put #Free, , Buff
    Close Free
End If

End Sub

Public Sub LoadHotKeys()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "LoadHotKeys()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Dim Buffer As String, lTmp%, lCrypt As Boolean, Free&

Free = FreeFile

If Dir(App.Path & "\Hotkey.dat") = "" Then Exit Sub

Open App.Path & "\Hotkey.dat" For Binary As Free
    Get #Free, , lTmp
    
    If lTmp < -1 Or lTmp > 0 Then lTmp = 0
    lCrypt = CBool(lTmp)
    
    If lCrypt Then
        Buffer = Space(LOF(1) - 2)
        Get #1, , Buffer
        
        Crypt.InBuffer = Buffer
        Crypt.Decrypt
        Buffer = Crypt.OutBuffer
        
        CopyMemory HotKey(0), Buffer, LenB(HotKey(0)) * 9
    Else
        Get #1, , HotKey
    End If
Close Free

End Sub

Public Sub RegisterHotKeys()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "RegisterHotKeys()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Dim A&

UnRegisterAll

For A = LBound(HotKey) To UBound(HotKey)
    If HotKey(A).Register = True And HotKey(A).ret = 0 Then
        HotKey(A).ret = RegisterHotKey(frmMain.hwnd, &HBFFF& + A, Choose(HotKey(A).Mod + 1, MOD_ALT, MOD_CONTROL, MOD_SHIFT), vbKey1 + A)
    End If
Next

End Sub

Public Sub UnRegisterAll()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "UnRegisterAll()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Dim A&

For A = LBound(HotKey) To UBound(HotKey)
    If HotKey(A).Register = True Then
        UnregisterHotKey frmMain.hwnd, &HBFFF& + A
        HotKey(A).ret = 0
    End If
Next

End Sub

Public Function IsCodeCompiled() As Boolean

On Error GoTo ErrorHandler

'Debug.Print 1 / 0
'IsCodeCompiled = True

Exit Function
ErrorHandler:
IsCodeCompiled = False
Exit Function

End Function

Public Sub InitializeVariables()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "InitializeVariables()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

ReDim FightList(8)

FightList(0) = "This player is too weak to attack"
FightList(1) = "This should be a fairly easy fight"
FightList(2) = "This should be a easy fight"
FightList(3) = "This should be a moderate fight"
FightList(4) = "This should be a close fight"
FightList(5) = "This should be a tough fight"
FightList(6) = "This should be a risky fight"
FightList(7) = "This should be a very hard fight"
FightList(8) = "This player is too powerful to attack"

End Sub

Public Sub AddFightListToComboBox(ComboBox As ComboBox)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "AddFightListToComboBox(ComboBox)", Array(ComboBox), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Dim A&

For A = LBound(FightList) + 1 To UBound(FightList) - 1
ComboBox.AddItem FightList(A)
Next

End Sub

Public Function GetFightType(Text As String) As Integer

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "GetFightType(Text)", Array(Text), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***

Dim A&

For A = LBound(FightList) To UBound(FightList)
If LCase(Text) = LCase(FightList(A)) Then GetFightType = A: Exit Function
Next

GetFightType = -1

End Function

Public Sub CheckForManifest()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "CheckForManifest()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Dim Path$

If IsCodeCompiled = False Then Exit Sub
Path = App.Path & "\" & App.EXEName & ".exe.manifest"

If Dir(Path) = "" Then

Open Path For Output As #1
Print #1, "<?xml version=" & Chr(34); "1.0" & Chr(34); " encoding=" & Chr(34) & "UTF-8" & Chr(34) & " standalone=" & Chr(34); "yes" & Chr(34); "?>"
Print #1, "<assembly xmlns=" & Chr(34) & "urn:schemas-microsoft-com:asm.v1" & Chr(34) & " manifestVersion=" & Chr(34) & "1.0" & Chr(34); ">"
Print #1, "<assemblyIdentity"
Print #1, "   version=" & Chr(34) & "1.0.0.0" & Chr(34)
Print #1, "   processorArchitecture=" & Chr(34) & "X86" & Chr(34)
Print #1, "   name=" & Chr(34) & "Microsoft.VB6.VBnetStyles" & Chr(34)
Print #1, "   type=" & Chr(34) & "win32" & Chr(34)
Print #1, "/>"
Print #1, "<description>VBnet Manifest for VB6 IDE</description>"
Print #1, "<dependency>"
Print #1, "   <dependentAssembly>"
Print #1, "     <assemblyIdentity"
Print #1, "       type=" & Chr(34) & "win32" & Chr(34)
Print #1, "       name=" & Chr(34) & "Microsoft.Windows.Common-Controls" & Chr(34)
Print #1, "       version=" & Chr(34) & "6.0.0.0" & Chr(34)
Print #1, "       processorArchitecture=" & Chr(34) & "X86" & Chr(34)
Print #1, "       publicKeyToken=" & Chr(34) & "6595b64144ccf1df" & Chr(34)
Print #1, "       language=" & Chr(34) & "*" & Chr(34)
Print #1, "     />"
Print #1, "   </dependentAssembly>"
Print #1, "</dependency>"
Print #1, "</assembly>"
Close #1

Shell App.Path & "\" & App.EXEName & ".exe"
End

End If

End Sub

Public Sub Main()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "Main()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Dim Buff$, Comm$, RegScript$

ErrSysHandlerSet
UpdateServer GetSetting("Outwar", "General", "Server", "www.outwar.com")
InitializeVariables
AddFightListToComboBox frmSettings.Combo2
LoadHotKeys
RegisterHotKeys

SetProp frmScript.hwnd, "DeTop", True
SetProp frmCode.hwnd, "DeTop", True
SetProp frmShowError.hwnd, "DeTop", True
SetProp frmMain.hwnd, "HandleMinMax", 1
SetProp frmMain.hwnd, "HandleHotKey", 1
SetProp About.hwnd, "TransDisable", 1
'modHooks.HookAll

Comm = GetCommLine
Buff = Mid(Comm, InStrRev(Comm, Chr(34)) + 1)

If Len(Buff) < 3 Then
    frmLogin.Show
    Exit Sub
End If

If GetSetting("Outwar", "Advance", "RunRegistry", 1) = 1 Then
    RegScript = GetSetting("Outwar", "General", "RegScript", "")
    If RegScript <> "" Then RunScript RegScript, True
End If

RunScript Buff
If LoggedIn = False Then frmLogin.Show

End Sub

Public Sub SetNumber(NumberText As TextBox, Flag As Boolean)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "SetNumber(NumberText, Flag)", Array(NumberText, Flag), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***
    
Dim curstyle As Long, newstyle As Long

curstyle = GetWindowLong(NumberText.hwnd, GWL_STYLE)
curstyle = IIf(Flag, curstyle Or ES_NUMBER, curstyle And (Not ES_NUMBER))

newstyle = SetWindowLong(NumberText.hwnd, GWL_STYLE, curstyle)
NumberText.Refresh
    
End Sub

Public Function RemoveLetters(Text As String) As Double

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "RemoveLetters(Text)", Array(Text), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***

Dim Buff$, A&

For A = 1 To Len(Text)
    If IsNumeric(Mid(Text, A, 1)) Then Buff = Buff & Mid(Text, A, 1)
Next

RemoveLetters = Val(Buff)

End Function

Public Function RegenerateLetters(ByVal Number As Double) As String

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "RegenerateLetters(Number)", Array(Number), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***

RegenerateLetters = Format(CStr(Number), "###,###,###,###,###")

End Function

Sub SaveString(hKey As Long, strPath As String, strValue As String, strData As String)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "SaveString(hKey, strPath, strValue, strData)", Array(hKey, strPath, strValue, strData), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***
    
Dim ret

RegCreateKey hKey, strPath, ret
RegSetValueEx ret, strValue, 0, REG_SZ, ByVal strData, Len(strData)
RegCloseKey ret
    
End Sub

Sub DelSetting(hKey As Long, strPath As String, strValue As String)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "DelSetting(hKey, strPath, strValue)", Array(hKey, strPath, strValue), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***
    
Dim ret

RegCreateKey hKey, strPath, ret
RegDeleteValue ret, strValue
RegCloseKey ret
    
End Sub

Public Function GetKeyValue(KeyRoot As Long, KeyName As String, SubKeyRef As String, ByRef KeyVal As String) As Boolean

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "GetKeyValue(KeyRoot, KeyName, SubKeyRef, KeyVal)", Array(KeyRoot, KeyName, SubKeyRef, KeyVal), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***
    
Dim i As Long
Dim rc As Long
Dim hKey As Long
Dim hDepth As Long
Dim KeyValType As Long
Dim tmpVal As String
Dim KeyValSize As Long

rc = RegOpenKeyEx(KeyRoot, KeyName, 0, KEY_ALL_ACCESS, hKey)
If (rc <> ERROR_SUCCESS) Then Exit Function

tmpVal = String$(1024, 0)
KeyValSize = 1024

rc = RegQueryValueEx(hKey, SubKeyRef, 0, KeyValType, tmpVal, KeyValSize)
If (rc <> ERROR_SUCCESS) Then Exit Function

If (Asc(Mid(tmpVal, KeyValSize, 1)) = 0) Then
    tmpVal = Left(tmpVal, KeyValSize - 1)
Else
    tmpVal = Left(tmpVal, KeyValSize)
End If

Select Case KeyValType
Case REG_SZ
    KeyVal = tmpVal
Case REG_DWORD
    For i = Len(tmpVal) To 1 Step -1
        KeyVal = KeyVal + Hex(Asc(Mid(tmpVal, i, 1)))
    Next
    KeyVal = Format$("&h" + KeyVal)
End Select

GetKeyValue = True
rc = RegCloseKey(hKey)
    
End Function

Public Function GetSavedCookie() As String

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "GetSavedCookie()", Array(), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***

Dim Buff$, UserName$, Cookie$, L&, A
Dim CookieFolder$, B%, C%, TheCookie$

On Error GoTo Feil:

CookieFolder = GetSpecialfolder(CSIDL_COOKIES)

UserName = Space(255)
L = 255

GetUserName UserName, L
UserName = Mid(UserName, 1, L - 1)

For C = 1 To 9
Buff = CookieFolder & "\" & UserName & "@outwar[" & C & "].txt"

If Dir(Buff) <> "" Then

Open Buff For Binary As #1
    Cookie = Space(FileLen(Buff))
    Get #1, , Cookie
Close #1

If Cookie <> "" Then Exit For
End If

If C = 9 Then GoTo Feil
Next

A = Split(Cookie, Chr(10))

TheCookie = A(0) & "=" & A(1) & ";"

For B = LBound(A) + 2 To UBound(A)
    If A(B) = "*" Then
    TheCookie = TheCookie & A(B + 1) & "=" & A(B + 2)
    Exit For
    End If
Next

GetSavedCookie = TheCookie

Exit Function
Feil:

GetSavedCookie = ""

End Function

Public Sub SaveCookie()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "SaveCookie()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Dim Buff$, UserName$, L&, A
Dim CookieFolder$, B, C%, D%, Tmp$

CookieFolder = GetSpecialfolder(CSIDL_COOKIES)

UserName = Space(255)
L = 255

GetUserName UserName, L
UserName = Mid(UserName, 1, L - 1)

For C = 1 To 9
    Buff = CookieFolder & "\" & UserName & "@outwar[" & C & "].txt"
    
    If Dir(Buff) <> "" Then
    
    A = Split(Cookie, ";")
    
    For D = LBound(A) To UBound(A)
        B = Split(A(D), "=")
        Tmp = Tmp & B(0) & Chr(10) & B(1) & Chr(10) & "outwar.com/" & Chr(10) & "*" & Chr(10)
    Next
    
    Open Buff For Output As #1
        Print #1, Tmp
    Close #1
    
    If Cookie <> "" Then Exit For
    End If
    
    If C = 9 Then Exit For
Next

End Sub

Private Function GetSpecialfolder(CSIDL As Long) As String

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "GetSpecialfolder(CSIDL)", Array(CSIDL), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***

Dim r As Long, Path$
Dim IDL As ITEMIDLIST

r = SHGetSpecialFolderLocation(100, CSIDL, IDL)

If r = NOERROR Then
Path = Space$(512)
r = SHGetPathFromIDList(ByVal IDL.mkid.cb, ByVal Path$)
GetSpecialfolder = Left$(Path, InStr(Path, Chr$(0)) - 1)
Exit Function
End If

GetSpecialfolder = ""
    
End Function

Public Sub CloseWinsock(Winsock As Winsock)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "CloseWinsock(Winsock)", Array(Winsock), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

With Winsock
If .State <> 0 Then
    .Close
    .RemotePort = 0
    .LocalPort = 0
    
    Do Until .State = 0
        Sleep 10
        DoEvents
    Loop
    
End If
End With

End Sub

Public Sub UpdateServer(strOutwarServer As String)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "UpdateServer(strOutwarServer)", Array(strOutwarServer), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

OutwarServer = strOutwarServer
strPage = "http://" & OutwarServer & "/page.php?x="
strProfile = "http://" & OutwarServer & "/profile.php?id="
strOutwar = "http://" & OutwarServer & "/"

End Sub

Public Function GetMessage() As Boolean

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "GetMessage()", Array(), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***

Msg_End = False
Msg_Result = 0
frmMessage.Show

Do Until Msg_End
    DoEvents
    Sleep 10
Loop

If Msg_Result = 1 Then GetMessage = True

End Function

Private Function GetCommLine() As String

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "GetCommLine()", Array(), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***

Dim RetStr As Long, SLen As Long
Dim Buffer As String

RetStr = GetCommandLine
SLen = lstrlen(RetStr)

If SLen > 0 Then
    GetCommLine = Space$(SLen)
    CopyMemory ByVal GetCommLine, ByVal RetStr, SLen
End If
    
End Function

Public Sub LoadElements(Text As String, aElements() As PropertyBag)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "LoadElements(Text, aElements())", Array(Text, aElements()), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

On Error Resume Next
Dim Tell&, Tmp, Busy As Boolean, Cnt&, Buff&

Erase aElements
Cnt = -1

For Tell = 1 To Len(Text)
    If Mid(Text, Tell, 1) = "<" And Not Busy Then
        If Mid(Text, Tell + 1, 1) <> "/" Then
            Cnt = Cnt + 1
            Buff = InStr(Tell + 1, Text, ">")
            
            ReDim Preserve aElements(Cnt)
            Set aElements(Cnt) = New PropertyBag
            
            Tmp = Split(Mid(Text, Tell + 1, Buff - Tell - 1), " ", 2)
            
            aElements(Cnt).WriteProperty "Name", Tmp(0)
            aElements(Cnt).WriteProperty "Extra", Tmp(1)
            aElements(Cnt).WriteProperty "Tag", Buff + 1
            
            Tmp(0) = LCase(Tmp(0))
            Tell = Buff
            
            If Not (LCase(Tmp(0)) = "br") Then Busy = True
        End If
    End If
    
    If Mid(Text, Tell, 1) = "<" And Busy Then
        If Mid(Text, Tell + 2, InStr(Tell + 2, Text, ">") - (Tell + 2)) = aElements(Cnt).ReadProperty("Name") Then
            aElements(Cnt).WriteProperty "Value", Mid(Text, aElements(Cnt).ReadProperty("Tag"), Tell - aElements(Cnt).ReadProperty("Tag"))
            Busy = False
        End If
    End If
Next

End Sub

Public Function RemoveHTMLTags(HTML As String) As String

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "RemoveHTMLTags(HTML)", Array(HTML), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***

Dim Tell&, Buff$, Char$, Num&, SkipChar As Boolean

Buff = Space(Len(HTML))

For Tell = 1 To Len(HTML)
    Char = Mid(HTML, Tell, 1)

    If Char = "<" Then SkipChar = True
    
    If SkipChar = False Then
        Num = Num + 1
        Mid(Buff, Num, 1) = Char
    End If
    
    If Char = ">" Then SkipChar = False
Next

RemoveHTMLTags = Left(Buff, Num)

End Function

Public Function FindElement(Elements() As PropertyBag, ByVal Name As String, Optional Start As Long = -1) As Long

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "FindElement(Elements(), Name, Start)", Array(Elements(), Name, Start), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***

Dim A&

Name = LCase(Name)
If Start < LBound(Elements) Then Start = LBound(Elements)

For A = Start To UBound(Elements)
    If LCase(Elements(A).ReadProperty("Name", "")) = Name Then
        FindElement = A
        Exit Function
    End If
Next

FindElement = -1

End Function

Public Sub AddLine(Text As String, Line As String, Optional Paragraph As Boolean)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "AddLine(Text, Line, Paragraph)", Array(Text, Line, Paragraph), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Text = Text & Line & vbCrLf & IIf(Paragraph, vbCrLf, "")

End Sub

Public Sub SaveChecks(Form As Form, Section As String)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "SaveChecks(Form, Section)", Array(Form, Section), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

On Error Resume Next
Dim Check As Control, Index&, Buff$

For Each Check In Form.Controls
    Buff = Mid(Check.Name, 1, 3)
    
    If Buff = "chk" Or Buff = "opt" Or Buff = "txt" Then
        Index = -1
        Index = Check.Index
        SaveSetting "Outwar", Section, Check.Name & IIf(Index >= 0, ";" & Index, ""), Check.Value
    End If
Next

End Sub

Public Function CheckStatusBar(Buff As String) As Long

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "CheckStatusBar(Buff)", Array(Buff), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***

Dim B&, C&, Elements() As PropertyBag, Data(3) As String

B = InStr(1, Buff, "<b>StatusBar</b>")

If B <> 0 Then
  
    C = InStr(B, Buff, "</table>")

    If C <> 0 Then
        LoadElements Mid(Buff, B, C - B), Elements
        
        C = -1
        
        For B = 0 To 3
            C = FindElement(Elements, "div", C + 1)
            Data(B) = Replace(Elements(C).ReadProperty("Value", ""), Chr(9), "")
        Next
    
        ' Update statusbar
        frmMain.StatusBar1.Panels(2).Text = "Next turn in " & RemoveLetters(Data(0)) & " minutes  "
        frmMain.StatusBar1.Panels(3).Text = "Money: $" & Mid(Data(1), InStr(1, Data(1), "</b>") + 14) & "  "
        frmMain.StatusBar1.Panels(4).Text = "Power: " & Mid(Data(2), InStr(1, Data(2), "</b>") + 5) & "  "
        frmMain.StatusBar1.Panels(5).Text = "Attacks: " & Mid(Data(3), InStr(1, Data(3), "</b>") + 5) & "  "
    Else
        CheckStatusBar = -1
    End If
    
End If

End Function

Public Sub GetChecks(Form As Form, Section As String)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "GetChecks(Form, Section)", Array(Form, Section), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

On Error Resume Next
Dim Check As Control, Index&, Buff$

For Each Check In Form.Controls
    Buff = Mid(Check.Name, 1, 3)
    
    If Buff = "chk" Or Buff = "opt" Or Buff = "txt" Then
        Index = -1
        Index = Check.Index
        Check.Value = GetSetting("Outwar", Section, Check.Name & IIf(Index >= 0, ";" & Index, ""), 1)
    End If
Next

End Sub

Public Function HexToString(Hex As String) As String

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "HexToString(Hex)", Array(Hex), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***

Dim Tell&, Tmp$, Buff$

For Tell = 1 To Len(Hex) Step 3
    Tmp = Mid(Hex, Tell, 3)
    
    If Mid(Tmp, 1, 1) = "%" Then
        Buff = Buff & Chr(Val("&H" & Mid(Tmp, 2, 2)))
    End If
Next

HexToString = Buff

End Function

Public Function GetVersion() As String

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "GetVersion()", Array(), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***

GetVersion = App.Major & "." & App.Minor & "." & App.Revision

End Function

Public Function StringToHex(Text As String) As String

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "StringToHex(Text)", Array(Text), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***

Dim Tell&, Buff$

Buff = Space(Len(Text) * 3)

For Tell = 1 To Len(Text)
    Mid(Buff, (Tell - 1) * 3 + 1, 3) = "%" & Hex(Asc(Mid(Text, Tell, 1)))
Next

StringToHex = Buff

End Function

Public Sub EventStarted(strEvent As String, Form As Form)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "EventStarted(strEvent, Form)", Array(strEvent, Form), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Dim Buffer As String, Free&
Dim Script As New clsScript

If LCase(strEvent) = "initialize" Then
    InitCommonControls
End If

If GetSetting("Outwar", "Advance", "InvokeFromFile", 1) = 0 Then
    Exit Sub
End If

If Dir(App.Path & "\Events.ext") <> "" Then

    Free = FreeFile
    
    Open App.Path & "\Events.ext" For Binary As Free
        Buffer = Space(LOF(1))
        Get #Free, , Buffer
    Close Free
    
    Buffer = "Const EventName = " & strEvent & vbNewLine & Buffer
    
    Set ScriptMe = Form
    
    InvokeCode Script, 1, Buffer
End If

End Sub

Public Sub OpenPage(ByVal URL As String)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "OpenPage(URL)", Array(URL), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

ShellExecute frmMain.hwnd, vbNullString, strOutwar & "members.php", vbNullString, "C:\", SW_SHOWNORMAL

End Sub

' ----------------- SORTIMG ALGORITHM ----------------------- '

Sub Selectionsort(List() As Member, min As Integer, max As Integer)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "Selectionsort(min, max)", Array(min, max), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***
    
Dim i As Integer
Dim j As Integer
Dim best_value As Long
Dim best_j As Integer, Save$

For i = min To max - 1
    best_value = List(i).Hits
    best_j = i
    
    For j = i + 1 To max
        If List(j).Hits < best_value Then
            best_value = List(j).Hits
            best_j = j
        End If
    Next
    
    Save = List(best_j).Name
    List(best_j).Hits = List(i).Hits
    List(best_j).Name = List(i).Name
    List(i).Hits = best_value
    List(i).Name = Save
Next
    
End Sub

