Attribute VB_Name = "modHooks"
Option Explicit

' This program automates different actions within Outwar, an RPG-game.
'Copyright (C) 2004  Kristian S.Stangeland
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Declare Function VirtualAlloc Lib "kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal flAllocationType As Long, ByVal flProtect As Long) As Long
Declare Function VirtualFree Lib "kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal dwFreeType As Long) As Long

Declare Function GetProp Lib "user32" Alias "GetPropA" (ByVal hwnd As Long, ByVal lpString As String) As Long
Declare Function SetProp Lib "user32" Alias "SetPropA" (ByVal hwnd As Long, ByVal lpString As String, ByVal hData As Long) As Long
Declare Function RemoveProp Lib "user32" Alias "RemovePropA" (ByVal hwnd As Long, ByVal lpString As String) As Long

Declare Function InsertMenuItem Lib "user32.dll" Alias "InsertMenuItemA" (ByVal hMenu As Long, ByVal uItem As Long, ByVal fByPosition As Long, lpmii As MENUITEMINFO) As Long
Declare Function SetMenuItemInfo Lib "user32.dll" Alias "SetMenuItemInfoA" (ByVal hMenu As Long, ByVal uItem As Long, ByVal fByPosition As Long, lpmii As MENUITEMINFO) As Long
Declare Function GetMenuString Lib "user32" Alias "GetMenuStringA" (ByVal hMenu As Long, ByVal wIDItem As Long, ByVal lpString As String, ByVal nMaxCount As Long, ByVal wFlag As Long) As Long
Declare Function SetLayeredWindowAttributes Lib "user32" (ByVal hwnd As Long, ByVal crKey As Long, ByVal bAlpha As Byte, ByVal dwFlags As Long) As Long

Type MENUITEMINFO
    cbSize As Long
    fMask As Long
    fType As Long
    fState As Long
    wID As Long
    hSubMenu As Long
    hbmpChecked As Long
    hbmpUnchecked As Long
    dwItemData As Long
    dwTypeData As String
    cch As Long
End Type

Type MINMAXINFO
    ptReserved As POINTAPI
    ptMaxSize As POINTAPI
    ptMaxPosition As POINTAPI
    ptMinTrackSize As POINTAPI
    ptMaxTrackSize As POINTAPI
End Type

Public Const LWA_COLORKEY = &H1
Public Const LWA_ALPHA = &H2
Public Const WS_EX_LAYERED = &H80000

Public Const GWL_WNDPROC = (-4)
Public Const MIIM_STATE = &H1
Public Const MIIM_ID = &H2
Public Const MIIM_TYPE = &H10

Public Const MFS_DISABLED = &H2
Public Const MFT_SEPARATOR = &H800
Public Const MFT_STRING = &H0
Public Const MFS_ENABLED = &H0
Public Const MFS_CHECKED = &H8

Public Const WM_MENUSELECT = &H11F
Public Const WM_NCDESTROY = &H82
Public Const WM_USER = &H400
Public Const WM_SYSCOMMAND = &H112
Public Const WM_INITMENU = &H116
Public Const WM_GETMINMAXINFO = &H24

Private Const PAGE_EXECUTE_READWRITE = &H40
Private Const MEM_COMMIT = &H1000
Private Const MEM_DECOMMIT = &H4000
Private Const MEM_RELEASE = &H8000

Dim hHook As Long, HookedWindows As New Collection

Private Function HookProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    
On Error Resume Next ' No point with real error handler in a subclass-proc
Dim A&, MM As MINMAXINFO, mData(3) As Long
Dim hSysMenu As Long, onTop As Boolean
Dim mii As MENUITEMINFO, PrevProc&, ret&

PrevProc = GetProp(hwnd, "PrevProc")

Select Case uMsg
Case WM_GETMINMAXINFO

    If GetProp(hwnd, "HandleMinMax") = 1 Then
        CopyMemory MM, ByVal lParam, Len(MM)
        
        mData(0) = GetProp(hwnd, "MinWidth")
        mData(1) = GetProp(hwnd, "MinHeight")
        mData(2) = GetProp(hwnd, "MaxWidth")
        mData(3) = GetProp(hwnd, "MaxHeight")
            
        If mData(0) <> 0 Then MM.ptMinTrackSize.x = mData(0)
        If mData(1) <> 0 Then MM.ptMinTrackSize.y = mData(1)
        If mData(2) <> 0 Then MM.ptMaxTrackSize.x = mData(2)
        If mData(3) <> 0 Then MM.ptMaxTrackSize.y = mData(3)
        
        CopyMemory ByVal lParam, MM, Len(MM)
        
        HookProc = 0
        Exit Function
    End If
    
Case WM_HOTKEY

    If GetProp(hwnd, "HandleHotKey") = 1 Then
        A = wParam - &HBFFF&
        
        If A >= LBound(HotKey) And A <= UBound(HotKey) Then
            If HotKey(A).Register = True Then
                frmLogin.txtUserName = Trim(HotKey(A).Email)
                frmLogin.txtPassword = Trim(HotKey(A).Password)
                frmLogin.Winsock1.Connect OutwarServer, 80
                LoggedIn = False
                
                Do Until LoggedIn
                    DoEvents
                    Sleep 10
                Loop
                
                SaveCookie
            End If
        End If
    End If
    
    HookProc = 0
    Exit Function

Case WM_INITMENU

    If GetProp(hwnd, "ItemAdded") = 0 Then
        AddMenuItems hwnd
    End If

    hSysMenu = GetSystemMenu(hwnd, 0)
    
    With mii
        .cbSize = Len(mii)
        .fMask = MIIM_STATE
        .fState = MFS_ENABLED Or IIf(GetProp(hwnd, "OnTop"), MFS_CHECKED, 0)
    End With
    
    A = SetMenuItemInfo(hSysMenu, 1, 0, mii)
    
    mii.fState = IIf(GetProp(hwnd, "TransDisable") = 1, MFS_DISABLED, MFS_ENABLED) Or IIf(GetProp(hwnd, "Transparent"), MFS_CHECKED, 0)
    A = SetMenuItemInfo(hSysMenu, 2, 0, mii)
    
    HookProc = 0
    Exit Function
    
Case WM_SYSCOMMAND

    If wParam = 1 Then
        onTop = Not CBool(GetProp(hwnd, "OnTop"))
        
        SetProp hwnd, "OnTop", onTop
        SetWindowPos hwnd, IIf(onTop, HWND_TOPMOST, HWND_NOTOPMOST), 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE
        
        HookProc = 0
        Exit Function
    ElseIf wParam = 2 Then
    
        If GetProp(hwnd, "TransDisable") = 1 Or GetSetting("Outwar", "Advance", "EnableTransparent", 1) = 0 Then
            HookProc = 0
            Exit Function
        End If
    
        onTop = Not CBool(GetProp(hwnd, "Transparent"))
             
        ret = GetWindowLong(hwnd, GWL_EXSTYLE)
        SetProp hwnd, "Transparent", onTop
        ret = ret Or WS_EX_LAYERED
        
        SetWindowLong hwnd, GWL_EXSTYLE, ret
        SetLayeredWindowAttributes hwnd, 0, IIf(onTop, GetSetting("Outwar", "General", "TransparentKey", 180), 255), LWA_ALPHA
        
        HookProc = 0
        Exit Function
    End If

Case WM_OUTWAR  ' Is outwar window

    HookProc = WM_OUTWAR
    Exit Function

Case WM_OUTWAR + 1 ' Run command

    Dim Buff As String

    CopyMemory ByVal VarPtr(Buff), ByVal lParam, 4
    RunScript Buff, False
    ZeroMemory ByVal VarPtr(Buff), 4
    
    HookProc = 0
    Exit Function
    
Case WM_OUTWAR + 2 ' Allocate memory

    HookProc = VirtualAlloc(ByVal 0&, wParam, MEM_COMMIT, PAGE_EXECUTE_READWRITE)
    Exit Function
    
Case WM_OUTWAR + 3 ' Free memory

    VirtualFree wParam, lParam, MEM_DECOMMIT
    HookProc = VirtualFree(wParam, lParam, MEM_RELEASE)
    Exit Function

Case WM_DESTROY, WM_NCDESTROY

    UnHookWindow hwnd
End Select

HookProc = CallWindowProc(PrevProc, hwnd, uMsg, wParam, lParam)

End Function

Public Sub AddMenuItems(hwnd As Long)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "AddMenuItems(hwnd)", Array(hwnd), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Dim hSysMenu As Long
Dim count As Long
Dim mii As MENUITEMINFO
Dim RetVal As Long

hSysMenu = GetSystemMenu(hwnd, 0)
count = GetMenuItemCount(hSysMenu)

With mii
    .cbSize = Len(mii)
    .fMask = MIIM_ID Or MIIM_TYPE
    .fType = MFT_SEPARATOR
    .wID = 0
End With

RetVal = InsertMenuItem(hSysMenu, count, 1, mii)

With mii
    .fMask = MIIM_STATE Or MIIM_ID Or MIIM_TYPE
    .fType = MFT_STRING
    .fState = MFS_ENABLED
    .wID = 1
    .dwTypeData = "&Always On Top"
    .cch = Len(.dwTypeData)
End With

RetVal = InsertMenuItem(hSysMenu, count + 1, 1, mii)

' Insert transparent menu item
mii.wID = 2
mii.dwTypeData = "&Transparent"

RetVal = InsertMenuItem(hSysMenu, count + 2, 1, mii)

SetProp hwnd, "OnTop", GetProp(hwnd, "DeTop")
SetProp hwnd, "Transparent", CBool(GetSetting("Outwar", "Advance", "TransparentDefault", 0) = 1)
SetProp hwnd, "ItemAdded", 1

End Sub

Public Sub HookWindow(hwnd As Long)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "HookWindow(hwnd)", Array(hwnd), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

If IsCodeCompiled = False Then
    ' Exit when we are in IDE
    Exit Sub
End If

If GetProp(hwnd, "PrevProc") <> 0 Then Exit Sub

HookedWindows.Add hwnd
SetProp hwnd, "PrevProc", SetWindowLong(hwnd, GWL_WNDPROC, AddressOf HookProc)

End Sub

Public Sub HookAll()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "HookAll()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

If IsCodeCompiled = False Then
    ' Exit when we are in IDE
    Exit Sub
End If

Dim Form As Form

For Each Form In Forms
    HookWindow Form.hwnd
Next

End Sub

Public Sub UnHookAll()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "UnHookAll()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

If IsCodeCompiled = False Then
    ' Exit when we are in IDE
    Exit Sub
End If

Dim Tell&

For Tell = 1 To HookedWindows.count
    UnHookWindow HookedWindows.Item(Tell)
Next

End Sub

Public Sub UnHookWindow(hwnd As Long)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "UnHookWindow(hwnd)", Array(hwnd), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

If IsCodeCompiled = False Then
    ' Exit when we are in IDE
    Exit Sub
End If

If GetProp(hwnd, "PrevProc") = 0 Then Exit Sub
SetWindowLong hwnd, GWL_WNDPROC, GetProp(hwnd, "PrevProc")

RemoveProp hwnd, "OnTop"
RemoveProp hwnd, "Transparent"
RemoveProp hwnd, "TransDisable"
RemoveProp hwnd, "MinWidth"
RemoveProp hwnd, "MinHeight"
RemoveProp hwnd, "MaxWidth"
RemoveProp hwnd, "MaxHeight"
RemoveProp hwnd, "HandleHotKey"
RemoveProp hwnd, "HandleMinMax"
RemoveProp hwnd, "DeTop"
RemoveProp hwnd, "ItemAdded"

End Sub
