VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsHTTP"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' This program automates different actions within Outwar, an RPG-game.
'Copyright (C) 2004  Kristian S.Stangeland
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Enum Command
    CMD_GET = 1
    CMD_POST = 2
End Enum

Private Cmd As Command
Private sURL As String
Private sReferer As String
Private sAccept As String
Private sUserAgent As String
Private sConnection As String
Private sContentType As String
Private sExtra As String
Private sCookie As String

Public Sub SendRequest(Winsock As Winsock)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "SendRequest(Winsock)", Array(Winsock.Parent.Name & "." & Winsock.Name), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

Dim strCommand As String

strCommand = Choose(Cmd, "GET ", "POST ") & sURL & " HTTP/1.1" & vbCrLf
strCommand = strCommand & "Host: " & Winsock.RemoteHost & vbCrLf
If sReferer <> "" Then strCommand = strCommand & "Referer: " & sReferer & vbCrLf
If sAccept <> "" Then strCommand = strCommand & "Accept: */*" & vbCrLf & "Accept: " & sAccept & vbCrLf
If sUserAgent <> "" Then strCommand = strCommand & "User-Agent: " & sUserAgent & vbCrLf
If sConnection <> "" Then strCommand = strCommand & "Connection: " & sConnection & vbCrLf
If sCookie <> "" Then strCommand = strCommand & "Cookie: " & sCookie & vbCrLf

If sContentType <> "" And sExtra <> "" Then
strCommand = strCommand & "Content-type: " & sContentType & vbCrLf
strCommand = strCommand & "Content-length: " & Len(sExtra) & vbCrLf & vbCrLf
strCommand = strCommand & sExtra
Else
    strCommand = strCommand & vbCrLf
    End If

If Winsock.State = sckConnected Then
Winsock.SendData strCommand
DoEvents
End If

End Sub

Public Property Get Command() As Command
Command = Cmd
End Property

Public Property Let Command(ByVal vNewValue As Command)
Cmd = vNewValue
End Property

Public Property Get Referer() As String
Referer = sReferer
End Property

Public Property Let Referer(ByVal vNewValue As String)
sReferer = vNewValue
End Property

Public Property Get Accept() As String
Accept = sAccept
End Property

Public Property Let Accept(ByVal vNewValue As String)
sAccept = vNewValue
End Property

Public Property Get UserAgent() As String
UserAgent = sUserAgent
End Property

Public Property Let UserAgent(ByVal vNewValue As String)
sUserAgent = vNewValue
End Property

Public Property Get Connection() As String
Connection = sConnection
End Property

Public Property Let Connection(ByVal vNewValue As String)
sConnection = vNewValue
End Property

Public Property Get ContentType() As String
ContentType = sContentType
End Property

Public Property Let ContentType(ByVal vNewValue As String)
sContentType = vNewValue
End Property

Public Property Get Extra() As String
Extra = sExtra
End Property

Public Property Let Extra(ByVal vNewValue As String)
sExtra = Replace(vNewValue, " ", "+")
End Property

Public Property Get URL() As String
URL = sURL
End Property

Public Property Let URL(ByVal vNewValue As String)
sURL = Replace(vNewValue, " ", "+")
End Property

Public Property Get Cookie() As String
Cookie = sCookie
End Property

Public Property Let Cookie(ByVal vNewValue As String)
sCookie = vNewValue
End Property

Private Sub Class_Initialize()
Cmd = CMD_GET
End Sub
