VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsScript"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Option Compare Text

' This program automates different actions within Outwar, an RPG-game.
'Copyright (C) 2004  Kristian S.Stangeland
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Dim bAsync As Boolean

Public Function CallGlobal(FunctionName As String, ParamArray Paramenters() As Variant)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "CallGlobal(FunctionName, Paramenters)", Array(FunctionName, Join(Paramenters, ",")), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***

Dim TmpObj As Object

Select Case FunctionName
Case "RemoveHTMLTags"
    CallGlobal = RemoveHTMLTags(CStr(Paramenters(0)))

Case "CancelIt"
    CallGlobal = CancelIt
    CancelIt = Paramenters(0)
    
Case "CheckForManifest"
    CheckForManifest
    
Case "ClassToNumber"
    CallGlobal = ClassToNumber(CStr(Paramenters(0)))
    
Case "CloseWinsock"
    Set TmpObj = Paramenters(0)
    
    CloseWinsock TmpObj
    
Case "CodeGot"
    CallGlobal = CodeGot
    CodeGot = Paramenters(0)
    
Case "Cookie"
    CallGlobal = Cookie
    Cookie = Paramenters(0)
    
Case "DownloadFile"
    CallGlobal = modGlobal.DownloadFile(CStr(Paramenters(0)), CStr(Paramenters(1)))
    
Case "GetChecks"
    Set TmpObj = Paramenters(0)

    modGlobal.GetChecks TmpObj, CStr(Paramenters(1))
    
Case "GetCommandLine"
    CallGlobal = modGlobal.GetCommandLine
    
Case "GetFightType"
    CallGlobal = GetFightType(CStr(Paramenters(0)))
    
Case "GetSavedCookie"
    CallGlobal = GetSavedCookie
    
Case "HexToString"
    CallGlobal = HexToString(CStr(Paramenters(0)))
    
Case "HaveSearched"
    CallGlobal = HaveSearched
    HaveSearched = Paramenters(0)
    
Case "Hitreason"
    CallGlobal = Hitreason
    Hitreason = Paramenters(0)
    
Case "InitializeVariables"
    InitializeVariables
    
Case "IsCodeCompiled"
    CallGlobal = IsCodeCompiled
    
Case "InvitePlayers"
    CallGlobal = InvitePlayers
    InvitePlayers = Paramenters(0)
     
Case "LoadHotKeys"
    LoadHotKeys
    
Case "LoggedIn"
    CallGlobal = LoggedIn
    LoggedIn = Paramenters(0)
    
Case "Main"
    Main
    
Case "MainBuff"
    CallGlobal = MainBuff
    MainBuff = Paramenters(0)
    
Case "Msg_End"
    CallGlobal = Msg_End
    Msg_End = Paramenters(0)
    
Case "Msg_Result"
    CallGlobal = Msg_Result
    Msg_Result = Paramenters(0)
    
Case "Msg_Subject"
    CallGlobal = Msg_Subject
    Msg_Subject = Paramenters(0)

Case "Msg_Text"
    CallGlobal = Msg_Text
    Msg_Text = Paramenters(0)
    
Case "OpenPage"
    OpenPage CStr(Paramenters(0))
    
Case "OutwarServer"
    CallGlobal = OutwarServer
    OutwarServer = Paramenters(0)

Case "RunScript"
    RunScript CStr(Paramenters(0)), CBool(Paramenters(1))
    
Case "SaveChecks"
    Set TmpObj = Paramenters(0)

    SaveChecks TmpObj, CStr(Paramenters(1))
    
Case "SaveCookie"
    SaveCookie
    
Case "SaveDatabase"
    SaveDatabase
    
Case "SetNumber"
    Set TmpObj = Paramenters(0)

    SetNumber TmpObj, CBool(Paramenters(1))
    
Case "StringToHex"
    CallGlobal = StringToHex(CStr(Paramenters(0)))
    
Case "UpdateServer"
    UpdateServer CStr(Paramenters(0))
    
Case "UnRegisterAll"
    UnRegisterAll
End Select

End Function

Public Function AddControl(Class As String, Name As String, Parent As Object) As Object

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "AddControl(Class, Name, Parent)", Array(Class, Name, Parent.Name), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***

Set AddControl = Parent.Controls.Add(Class, Name)

End Function

Public Function LoadSetting(Section As String, Key As String) As String

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "LoadSetting(Section, Key)", Array(Section, Key), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***

LoadSetting = GetSetting("Outwar", Section, Key, "")

End Function

Public Sub SetSetting(Section As String, Key As String, Value As String)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "SetSetting(Section, Key, Value)", Array(Section, Key, Value), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

SaveSetting "Outwar", Section, Key, Value

End Sub

Public Sub ShowAbout()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "ShowAbout()", Array(), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

About.MainLoop

End Sub

Public Sub Command(Line As String)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "Command(Line)", Array(Line), EA_NORERAISE: HandleError: Exit Sub
End If
' *** BEGIN CODE ***

RunScript Line, False

End Sub

Public Function GetFreeSocket()

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "GetFreeSocket()", Array(), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***

Dim Tmp&

Tmp = -1

Do While Tmp < 0
    GetFreeSocket = frmMain.GetFreeSocket
    Sleep 10
    DoEvents
Loop

End Function

Public Function DownloadFile(URL As String)

' *** START ERROR HANDLER ***
On Error GoTo errHandler
If Err.Number <> 0 Then
errHandler: ErrorIn "DownloadFile(URL)", Array(URL), EA_NORERAISE: HandleError: Exit Function
End If
' *** BEGIN CODE ***

Dim Tmp&

Select Case bAsync
Case 0
    frmMain.DownloadFile frmMain.Winsock1, URL, False
Case 1
    Tmp = GetFreeSocket

    frmMain.Attacks(Tmp).Tag = URL
    frmMain.DownloadFile frmMain.Attacks(Tmp), "", True
End Select

End Function

Public Property Get Async() As Boolean
Async = bAsync
End Property

Public Property Let Async(ByVal vNewValue As Boolean)
bAsync = vNewValue
End Property

Public Property Get MainBuffer() As String
MainBuffer = MainBuff
End Property

Public Property Let MainBuffer(ByVal vNewValue As String)
MainBuff = vNewValue
End Property

Public Property Get Mode() As Integer
Mode = InvitePlayers
End Property

Public Property Let Mode(ByVal vNewValue As Integer)
InvitePlayers = vNewValue
End Property

Public Property Get Ver() As String
Ver = GetVersion
End Property

Public Property Let NoClick(ByVal vNewValue As Long)
SaveSetting "Outwar", "General", "DoNotClick", vNewValue
End Property

Public Property Get NoClick() As Long
NoClick = GetSetting("Outwar", "General", "DoNotClick", 0)
End Property

Public Property Let Link(ByVal vNewValue As Long)
SaveSetting "Outwar", "General", "Link", vNewValue
End Property

Public Property Get Link() As Long
Link = GetSetting("Outwar", "General", "Link", 1648402)
End Property

Public Property Let LinkTorax(ByVal vNewValue As Boolean)
SaveSetting "Outwar", "General", "LinkTorax", vNewValue
End Property

Public Property Get LinkTorax() As Boolean
LinkTorax = GetSetting("Outwar", "General", "LinkTorax", False)
End Property

Public Property Let CurrentCookie(ByVal vNewValue As String)
Cookie = vNewValue
End Property

Public Property Get CurrentCookie() As String
CurrentCookie = Cookie
End Property
